/**
 * @packageDocumentation
 * @module Helpers
 */

/**
 * A string accompanied by a style tag.
 */

/**
 * @ignore
 */
const tagRegex = /^<(?<tag>\w+)>(?<text>.+?)<\/\k<tag>>/s;
/**
 * @ignore
 */

const beforeTagRegex = /^(?<text>.+?)(?=<\w+?>)/s;
/**
 * Creates an array of [[ParsedJSXText]] from a string, separating the string into substrings accompanied by a tag.
 */

const parseNextChunk = textToParse => {
  const tagMatch = tagRegex.exec(textToParse);
  const beforeTagMatch = beforeTagRegex.exec(textToParse);
  let tag = 'none';
  let text = '';
  let nextIndex = textToParse.length;

  if (tagMatch) {
    var _tagMatch$groups$tag, _tagMatch$groups, _tagMatch$groups$text, _tagMatch$groups2;

    tag = (_tagMatch$groups$tag = (_tagMatch$groups = tagMatch.groups) === null || _tagMatch$groups === void 0 ? void 0 : _tagMatch$groups.tag) !== null && _tagMatch$groups$tag !== void 0 ? _tagMatch$groups$tag : '';
    text = (_tagMatch$groups$text = (_tagMatch$groups2 = tagMatch.groups) === null || _tagMatch$groups2 === void 0 ? void 0 : _tagMatch$groups2.text) !== null && _tagMatch$groups$text !== void 0 ? _tagMatch$groups$text : '';
    nextIndex = tagMatch[0].length;
  } else if (beforeTagMatch) {
    var _beforeTagMatch$group, _beforeTagMatch$group2;

    text = (_beforeTagMatch$group = (_beforeTagMatch$group2 = beforeTagMatch.groups) === null || _beforeTagMatch$group2 === void 0 ? void 0 : _beforeTagMatch$group2.text) !== null && _beforeTagMatch$group !== void 0 ? _beforeTagMatch$group : '';
    nextIndex = beforeTagMatch[0].length;
  } else {
    text = textToParse;
  }

  const result = [{
    tag,
    text
  }];

  if (textToParse.length > 0) {
    return [...result, ...parseNextChunk(textToParse.substring(nextIndex))];
  }

  return result;
};

export const parseTextForJSX = parseableText => parseNextChunk(parseableText);
//# sourceMappingURL=parseTextForJSX.js.map